/*
 * invalidation.h		This module implemented invalidation
 *
 * Authors:	Ming Zhao
 */

#include <stdio.h>
#include <stdlib.h>
#include "nfs_prot.h"
#include "nfs3_prot.h"
#include "logging.h"
#include <string.h>
#include "cache_attrib.h"
#include "cache_data.h"
#include "sk.h"

typedef struct inval_node_attr {
	nfs_fh3 file;
} inv_node_attr;

typedef struct inval_node_diro {
	nfs_fh3 dir;
	char *name;
} inv_node_diro;

typedef struct inval_node {
	u_int flag;
	union {
		inv_node_attr attr;
		inv_node_diro diro;
	} info;
	u_int client_id;
} inv_node;

typedef struct inval_cache_ent {
	char file[NFS3_FHSIZE];
	u_int tstamp;
} inv_cache_ent;

extern inv_node *inval_list;
extern int inval_index;
extern int inval_base;
extern u_int inval_tstamp;
extern u_int client_tstamps[MAX_CLIENT_NUM];
extern uint32 getinv_calls;
extern int sync_interval;
extern int inv_min_interval;
extern int inv_max_interval;
extern int inval_init();
extern int inval_insert(nfs_fh3 file, char *name, int client_id);
extern int addapage();

int lookup_fh_cache(nfs_fh3 file, int client_id);
int getinv();
