/*
 * Copyright (c) 2002-2005, In-VIGO Team
 * Advanced Computing and Information Systems (ACIS) Laboratory
 * University of Florida
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * sk.h		This module implements inter-proxy session key authentication.
 *
 * Author:	Ming Zhao
 */

#define MAX_CLIENT_NUM 100

/* Global variable that stores client's id after the client is authenticated
	 and identified by its session key */
extern int	client_id;
extern int	send_sk_enabled;
extern int	match_sk_enabled;
extern char	send_sk[16];
extern char	recv_sk[16];
extern char	match_sk[16*MAX_CLIENT_NUM];
extern char	*send_sk_path;
extern char  	*match_sk_path;
extern int	sk_no;

extern int	sk_init(char *send_sk_path, char *match_sk_path);
extern void	sk_match(void);
extern int	auth_sk(struct svc_req *rqstp);
int		sk_pack(char *machname);
